
# to run this script in irc channel
# python bot_learning_definitions.py irc.freenode.net '#algolit' monster

from __future__ import division
import re
from pattern.en import parse
from random import choice, shuffle
from time import sleep
import sys
import irc.bot

## FUNCTIONS

# for each sentence of the novel
def tagging(phrases):
	data = set()
	for s in phrases:
		# tokenize sentence & define POS
		par = parse(s, 
					tokenize = True,         # Split punctuation marks from words?
					tags = True,         # Parse part-of-speech tags? (NN, JJ, ...)
					chunks = False,         # Parse chunks? (NP, VP, PNP, ...)
					relations = False,        # Parse chunk relations? (-SBJ, -OBJ, ...)
					lemmata = False,        # Parse lemmata? (ate => eat)
					encoding = 'utf-8'       # Input string encoding
					)  
		# get word/POS in a list
		words = par.split(" ")
		#print words

		# separate word + POS as sublist
		for word in words:
			pair = word.split("/")
			if len(pair) == 2:
				pair = tuple(pair)
				data.add(pair)
	return data


# tag novel
with open("frankenstein.txt", "r") as novel:
	txt = ''.join(novel.readlines())
	phrases = re.split(r' *[\.\?!][\'"\)\]]* *', txt)
# tag frankenstein novel    
data = tagging(phrases)
#print "data:", data

# create dictionary of POS tags with possible words
tag_dictionary = {}
for word,tag in data:
	try:
		tag_dictionary[tag].append(word)
	except KeyError:
		tag_dictionary[tag] = [word]



# Actions bot
class MyBot(irc.bot.SingleServerIRCBot):
	def __init__(self, channel, nickname, server, port=6667):
		irc.bot.SingleServerIRCBot.__init__(self, [(server, port)], nickname, nickname)
		self.channel = channel

	def on_welcome(self, c, e):
		c.join(self.channel)
		print "join"
		
	def on_privmsg(self, c, e):
		pass

	def on_pubmsg(self, c, e):
		print "ok"
		# e.target, e.


# Actions bot
class MyBot(irc.bot.SingleServerIRCBot):
	def __init__(self, channel, nickname, server, port=6667):
		irc.bot.SingleServerIRCBot.__init__(self, [(server, port)], nickname, nickname)
		self.channel = channel

	def on_welcome(self, c, e):
		c.join(self.channel)
		print "join"
		
	def on_privmsg(self, c, e):
		pass

	def on_pubmsg(self, c, e):
		print "ok"
		# e.target, e.source, e.arguments, e.type
		# captures last line in chat
		print e.arguments
		msg = e.arguments[0]
		print msg
		# add a condition to call this bot
		#call = r'\bis\b'
		# if re.search(call, msg):
		# splits chat message in wordlist
		words = msg.split()
		# tag words of last line of chat
		sentence = tagging(words)
		# select tags only 
		tags_message = []
		for s in sentence:
			tag = s[1]
			tags_message.append(tag)
		# rewrite message using random selection from tag_dictionary novel
		new_message = []
		for t in tags_message:
			if t in tag_dictionary:
				new_word = choice(tag_dictionary[t]).lower()
				new_message.append(new_word)
		# convert list into string
		new_message = " ".join(new_message)
		# capitalize sentence
		reply = new_message.capitalize()
		c.privmsg(self.channel, reply)
		sleep(10)


# Launch bot
if __name__ == "__main__":
	import sys
	if len(sys.argv) != 4:
		print "Usage: bot_learning_definitions.py <server[:port]> <channel> <nickname>"
		sys.exit(1)
	s = sys.argv[1].split(":", 1)
	server = s[0]
	if len(s) == 2:
		try:
			port = int(s[1])
		except ValueError:
			print "Error: Erroneous port."
			sys.exit(1)
	else:
		port = 6667
	channel = sys.argv[2]
	nickname = sys.argv[3]
	bot = MyBot(channel, nickname, server, port)
	bot.start()
