# to run this script in irc channel
# python monkbot.py irc.freenode.net '#algolit' monk

from __future__ import division
import sys
import irc.bot
import os
import time
import subprocess
import re


# Functions

# transformation of the message to text file
def writing(msg):
    with open("notebook.txt", "a") as logbook:
        logbook.write(msg)
    return logbook

# copy last 10 lines -1 to other file
def cutting(notebook):
    now = time.strftime("%Y-%m-%d_%H:%M:%S")
    filename = now+'selection.txt'
    edit = "tail -n 10 notebook.txt | sed '$d'"
    note = subprocess.check_output(edit, shell=True)
    with open(filename, "w") as text:
        text.write(note)

# other way of deleting last line (grep) of chat:
# filename = now+'selection.txt'
# with open("notebook.txt", "r") as logbook:
    # lines = logbook.readlines()
    # print lines
# with open(filename, "w") as text:
#     text.writelines([item for item in lines[:-1]])



# Actions bot
class MyBot(irc.bot.SingleServerIRCBot):
    def __init__(self, channel, nickname, server, port=6667):
        irc.bot.SingleServerIRCBot.__init__(self, [(server, port)], nickname, nickname)
        self.channel = channel

    def on_welcome(self, c, e):
        c.join(self.channel)
        print "join"
        
    def on_privmsg(self, c, e):
        pass

    def on_pubmsg(self, c, e):
        # e.target, e.source, e.arguments, e.type
        #logs = []
        #call = r'\w{20, 50}' 
        call = r'\bgrep\b'
        # captures last line in chat
        msg = e.arguments[0]
        tstr = time.strftime("%H:%M:%S", time.localtime())
        nick = e.source.split("!", 1)[0]
        out = u"({0}) {1}: {2}".format(tstr, nick, msg)
        sys.stdout.write(out.encode("utf-8")+"  \n")
        sys.stdout.flush()
        logbook = writing(out+"  \n")
        #words = msg.split(" ")
        #for word in words:
            #if word == "yes":
        if re.search(call, msg):
            cutting(logbook)
                

# Launch bot
if __name__ == "__main__":
    import sys
    if len(sys.argv) != 4:
        print "Usage: editing_bot.py <server[:port]> <channel> <nickname>"
        sys.exit(1)
    s = sys.argv[1].split(":", 1)
    server = s[0]
    if len(s) == 2:
        try:
            port = int(s[1])
        except ValueError:
            print "Error: Erroneous port."
            sys.exit(1)
    else:
        port = 6667
    channel = sys.argv[2]
    nickname = sys.argv[3]
    bot = MyBot(channel, nickname, server, port)
    bot.start()

